<script lang="ts">
	import { onMount } from 'svelte'
	import { fly } from 'svelte/transition'
	import ProfileHeader from './ProfileHeader.svelte'
	let sidebarElement: HTMLDivElement = $state()
	let animateDelay = $state(false)
	let touchStartX = 0
	let touchStartAt = 0
	interface Props {
		username?: string | undefined;
		email?: string | undefined;
		avatar?: string;
		items?: Array<{ title: string; items: Array<{ name: string; link: string }> }>;
		isOpen?: boolean;
	}

	let {
		username = undefined,
		email = undefined,
		avatar = '',
		items = [],
		isOpen = $bindable(false)
	}: Props = $props();

	onMount(() => {
		document.body.addEventListener('touchstart', (e) => {
			touchStartX = e.touches[0].clientX
			touchStartAt = Date.now()
		})
		document.body.addEventListener('click', click)
		document.body.addEventListener('touchend', touchend)
		setTimeout(() => (animateDelay = true), 1)
	})

	function touchend(e: TouchEvent) {
		const touchEndX = (e as TouchEvent).changedTouches?.[0].clientX
		if (!touchEndX) return

		if (isOpen) {
			if (!sidebarElement) return
			if (touchEndX > sidebarElement.clientWidth || touchEndX - touchStartX < -50) {
				isOpen = false
			}

			return
		}

		const screenWidth = document.body.clientWidth
		const touchDistance = touchEndX - touchStartX

		const swipedFarEnough = touchDistance > screenWidth / 8
		const swipeStartZone = touchStartX < screenWidth / 4

		if (!swipeStartZone) return
		if (!swipedFarEnough) return

		if (Date.now() - touchStartAt > 200) {
			return
		}

		isOpen = true
	}

	function click(e: MouseEvent) {
		if (!sidebarElement) return
		if (isOpen && e.x > sidebarElement.clientWidth) {
			isOpen = false
		}
	}
</script>

{#if animateDelay && isOpen}
	<div transition:fly|global={{ x: -20, duration: 200 }} id="sidebar" bind:this={sidebarElement}>
		<div class="profile">
			<ProfileHeader {avatar} name={username} {email} avatarSize={'64px'} />
		</div>

		<br />
		<br />
		<div class="content">
			{#each items as header}
				<h3 class="header">{header.title}</h3>
				{#each header.items as item}
					<h3 class="subheader"><a href={item.link} onclick={() => (isOpen = false)}>{item.name}</a></h3>
				{/each}
			{/each}
		</div>
	</div>
{/if}

<style>
	#sidebar {
		position: fixed;
		z-index: 9999;
		user-select: none;
		min-width: 12rem;
		max-width: 40rem;
		height: 100%;
		width: 80vw;
		box-shadow: 9px -4px 13px -3px rgba(0, 0, 0, 0.43);
		background-color: #1d1d1dff;
		display: flex;
		flex-direction: column;
	}

	h1 {
		text-align: center;
		color: var(--accentColour);
	}

	.header {
		color: #898989;
		text-align: left;
		margin-left: 20px;
		margin-bottom: 30px;
		font-size: 1em;
	}

	a {
		color: #bcbcbc;
		text-decoration: none;
	}

	.subheader {
		color: #bcbcbc;
		text-align: left;
		margin-left: 50px;
		margin-bottom: 30px;
		font-size: 1em;
	}

	.avatar {
		margin: 0 auto;
		max-width: 10rem;
		border-radius: 50%;
		overflow: hidden;
		display: flex;
		align-items: center;
		justify-content: center;
	}

	.avatar img {
		width: 100%;
		height: 100%;
		object-fit: cover;
	}

	.profile {
		background-color: #00000044;
		padding-bottom: 2rem;
	}

	@media (pointer: none), (pointer: coarse) {
		.content {
			margin-top: auto;
			margin-bottom: 8rem;
		}
	}
</style>
